# class ActiveSupport::SafeBuffer

### Constants

UNSAFE_STRING_METHODS

### Public Class Methods

new(*) click to toggle source

    # File lib/active_support/core_ext/string/output_safety.rb, line 118
    def initialize(*)
      @html_safe = true
      super
    end

### Public Instance Methods

+(other) click to toggle source

    # File lib/active_support/core_ext/string/output_safety.rb, line 143
    def +(other)
      dup.concat(other)
    end

<<(value) click to toggle source
Alias for: concat
[](*args) click to toggle source

    # File lib/active_support/core_ext/string/output_safety.rb, line 101
    def [](*args)
      return super if args.size < 2

      if html_safe?
        new_safe_buffer = super
        new_safe_buffer.instance_eval { @html_safe = true }
        new_safe_buffer
      else
        to_str[*args]
      end
    end

clone_empty() click to toggle source

    # File lib/active_support/core_ext/string/output_safety.rb, line 128
    def clone_empty
      new_safe_buffer = self[0, 0]
      new_safe_buffer.instance_variable_set(:@dirty, @dirty)
      new_safe_buffer
    end

concat(value) click to toggle source

    # File lib/active_support/core_ext/string/output_safety.rb, line 134
    def concat(value)
      if !html_safe? || value.html_safe?
        super(value)
      else
        super(ERB::Util.h(value))
      end
    end

Also aliased as: original_concat, <<
encode_with(coder) click to toggle source

    # File lib/active_support/core_ext/string/output_safety.rb, line 159
    def encode_with(coder)
      coder.represent_scalar nil, to_str
    end

html_safe?() click to toggle source

    # File lib/active_support/core_ext/string/output_safety.rb, line 147
    def html_safe?
      defined?(@html_safe) && @html_safe
    end

initialize_copy(other) click to toggle source

    # File lib/active_support/core_ext/string/output_safety.rb, line 123
    def initialize_copy(other)
      super
      @html_safe = other.html_safe?
    end

original_concat(value) click to toggle source
Alias for: concat
safe_concat(value) click to toggle source

    # File lib/active_support/core_ext/string/output_safety.rb, line 113
    def safe_concat(value)
      raise SafeConcatError unless html_safe?
      original_concat(value)
    end

to_param() click to toggle source

    # File lib/active_support/core_ext/string/output_safety.rb, line 155
    def to_param
      to_str
    end

to_s() click to toggle source

    # File lib/active_support/core_ext/string/output_safety.rb, line 151
    def to_s
      self
    end

to_yaml(*args) click to toggle source

    # File lib/active_support/core_ext/string/output_safety.rb, line 163
    def to_yaml(*args)
      return super() if defined?(YAML::ENGINE) && !YAML::ENGINE.syck?
      to_str.to_yaml(*args)
    end